#pragma once

#include "Application.h"
#include "TipModel.h"
#include "TipView.h"
#include "TipControl.h"
#include "WindowScriptletPlugin.h"
#include <memory>
#include <atlpath.h>

namespace tipuio {

class NPCOMMONUI_API TipApplication
{
public:
	TipApplication(void) {}
	virtual ~TipApplication(void) {}

public:
	void Run()
	{
		Application* application = Application::get_instance();
		
		application->Init(GetMVCFactory());
		if (PreMessageLoop() == TRUE)
		{
			RunMessageLoop();
		}
		PostMessageLoop();
		application->Close();

		Application::release_instance();
	}

protected:
	virtual IMVCFactory* GetMVCFactory() = 0;
	virtual BOOL PreMessageLoop() { return TRUE; }
	virtual BOOL PostMessageLoop() { return TRUE; }
	virtual void RunMessageLoop()
	{
		Application* application = Application::get_instance();
		application->PreRun();
		application->Run();	
		application->PostRun();
	}
};

};